<?php namespace RWMedia\Analyze;

function facebook($args) {
	
	[
		'inputUrl' => $inputUrl,
	] = $args;
	
	$output = [];
	
	function isFacebookVideo($data) {
		// preg_match('/(videos\/\d+\?_fb_noscript=1)|(live.*?_fb_noscript=1)/', $data, $matches);
		preg_match('/(meta.property="og:video:url)/', $data, $matches);
		
		return (count($matches) > 0);
	}
	
	function getFacebookImageUrl($data) {
		preg_match('/(https:\/\/scontent.*?)"/', $data, $matchedImages);
		
		$matchesLength = count($matchedImages);
		
		if ($matchesLength > 0) {
			$imageUrl = $matchedImages[$matchesLength-1];
			$imageUrl = htmlspecialchars_decode($imageUrl);
		}
		
		return $imageUrl;
	}
	
	// Get data 
	$facebookResponseArr = \RWHttp::request([
		'url' => $inputUrl,
	]);
	
	if ($facebookResponseArr['headers']['status-code'] === '200') {
		$data = $facebookResponseArr['data'];

		//try if URL=video
		if (isFacebookVideo($data)) {
			$streamableShortcode = streamableUpload($inputUrl);
			
			$output = [
				'status' => 3, //3=processing
				'type' => 'video-streamable',
				'dataUrl' => $streamableShortcode,
			];
		}
		//else try if URL=image
	    else {
			$facebookImageUrl = getFacebookImageUrl($data);

			if ($facebookImageUrl) {
				$imgurOutput = imgurUpload($facebookImageUrl);
				
				$output = [
					'status' => 8, //8=Finished
					'type' => 'image-imgur',
					'displayUrl' => $imgurOutput['displayUrl'],
					'backgroundUrl' => $imgurOutput['backgroundUrl'],
					'title' => $imgurOutput['imageType'],
				];
			}
			//else no image

		}
	}
	
	return $output;	
}


?>