<?php namespace RWMedia\Analyze;

function imgur($args) {
	
	[
		'inputUrl' => $inputUrl,
	] = $args;
		
	$imgurClientId = \RWMedia\settings()['credentials']['imgur']['clientId'];
	
	// converts back to original imgur link, get ID
	if (preg_match('/.com\/(\w+)/i', $inputUrl, $matches)) {
		$id = $matches[1];
		
		$request = [
			'url' => "https://api.imgur.com/3/image/$id",
			'customHeaders' => [
				"Authorization: Client-ID $imgurClientId",
			],
		];
		
		$responseArr = \RWHttp::request($request);
		
		//TODO handle errors, status-code!=200
		
		$reply = json_decode($responseArr['data']);
		$replyDebug = json_decode($responseArr['data'], true);
		$replyRequest = $responseArr['request'];
		
		$displayUrl = 'https://imgur.com/'.$reply->data->id;
		
		if (($reply->data->type == "video/mp4" || $reply->data->type == "image/gif") && $reply->data->animated) {
			$type = "video-imgur";
			
			if (preg_match('/.com\/(\w+)/i', $reply->data->gifv, $matches)) {
				$id = $matches[1];
			}
			
			$webmUrl = 'http://i.imgur.com/'.$id.'.webm';
			$mp4Url = 'http://i.imgur.com/'.$id.'.mp4';
			$backgroundUrl =  'http://i.imgur.com/'.$id.'l.jpg';
		}
		else {
			$type = "image-imgur";
			$backgroundUrl = $reply->data->link;
			$height = $reply->data->height;
			$width = $reply->data->width;
			$title = $reply->data->description;
		}
		
		$output = [
			'status' => 8, //8=finished
			'type' => $type,
			'displayUrl' => $displayUrl,
			'width' =>$width,
			'height' => $height,
			
			// 'dataUrl' => $dataUrl,
			'webmUrl' =>$webmUrl,
			'mp4Url' => $mp4Url,
			'title' => $title,
			'videoDuration' => $videoDuration,
			'backgroundUrl' => $backgroundUrl,
			'debugData' => $replyDebug, //for developping or debugging purposes
			'debugRequest' => $replyRequest, //for developping or debugging purposes
		];
		
		return $output;
	}
}

function imgurUpload($inputUrl) {
	$imgurClientId = \RWMedia\settings()['credentials']['imgur']['clientId'];
	
	// Get Imgur data
	$request = [
		'url' => 'https://api.imgur.com/3/image',
		'customHeaders' => [
			"Authorization: Client-ID $imgurClientId",
		],
		'requestType' => 'POST',
		'data' => [
			'image' => $inputUrl,
		],
	];
	$responseArr = \RWHttp::request($request);
	//TODO handle errors, status-code!=200
	
	$data = json_decode($responseArr['data']);
	
	$displayUrl = 'https://imgur.com/' . $data->data->id;
	$backgroundUrl = $data->data->link;
	$imageType = $data->data->type;
	
	$output = [
		'displayUrl' => $displayUrl,
		'backgroundUrl' => $backgroundUrl,
		'imageType' => $imageType,
	];
	
	return $output;
}

?>