<?php namespace RWMedia\Analyze;
	
function vimeo($args) {
	
	[
		'inputUrl' => $inputUrl,
	] = $args;
	
	$type = "video-vimeo";
	$id = '';
	$output = [];
	
	//get Vimeo ID
	$pattern = '/vimeo.com\/(video\/)?(\d+)/i';
	
	preg_match($pattern, $inputUrl, $matches);
	if (count($matches)) {
		$id = $matches[2];
	}

	if ($id !== '') {
		
		// get background image, title, and duration from Vimeo
		$data = file_get_contents("https://vimeo.com/api/oembed.json?url=https%3A//vimeo.com/$id");
		$data = json_decode($data);
		$title = $data->title;
		$videoDuration = $data->duration;
		
		// duration is displayed on seconds. Lets convert it to hh:mm:ss
		$hms = "";
		$hours = intval(intval($videoDuration) / 3600);
		$hms .= ($hours)
			? str_pad($hours, 2, "0", STR_PAD_LEFT) . ':'
			: $hours . ':';
		$minutes = intval(($videoDuration / 60) % 60);
		$hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT) . ':';
		$seconds = intval($videoDuration % 60);
		$hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);
		$videoDuration = $hms;
		
		$backgroundUrl = $data->thumbnail_url;
		
		//build data URL
		$api = "https://player.vimeo.com/video/$id?";
		$options = [
			'autoplay' => 1,
			'color' => 333,
			'portrait' => 0,
		];
		$query = http_build_query($options);
		$dataUrl = $api.$query;
		
		$output = [
			'status' => 8, //8=finished
			'type' => $type,
			// 'displayUrl' => $displayUrl,
			'dataUrl' => $dataUrl,
			'title' => $title,
			'videoDuration' => $videoDuration,
			'backgroundUrl' => $backgroundUrl,
		];
	
	}
	
	return $output;
}


?>