<?php namespace RWMedia\Analyze;
	
function youtube($args) {
	
	[
		'inputUrl' => $inputUrl,
	] = $args;
	
	$type = "video-youtube";
	
	//get Youtube ID
	$pattern = '/(?<=\d\/|\.be\/|v[=\/])([\w\-]{11,})|^([\w\-]{11})|\/embed\/([\w\-]{11})/i';
	preg_match($pattern, $inputUrl, $matches);
    if (count($matches)) {
		$matches = end($matches);
		$id = $matches;
    }
	else $id = 'dQw4w9WgXcQ';
	
    //get video start time
    $pattern = '/t=((\d+h)?(\d+m)?(\d+[s]?)?)/'; //get every type of youtube timecode
    preg_match($pattern, $inputUrl, $matches);
    if (count($matches)) {
       $videoStartTime = $matches[1];
    }
    else $videoStartTime = 0;
	
	preg_match('/start=([0-9]+)/i', $videoStartTime, $matches); //if typecode = seconds only in digits
	if (count($matches)) {
       $videoStartTime = $matches[1];
    }
	else {//we need to convert it to seconds only in digits
		preg_match('/(\d+)h/i', $videoStartTime, $matches); //get hours
		if (count($matches)) {
			$hours = $matches[1];
			$hours = intval($hours);
			$hours = $hours * 60 * 60;
			$totaltime = $hours;
		}
	
		preg_match('/(\d+)m/i', $videoStartTime, $matches); //get minutes
		if (count($matches)) { 
			$minutes = $matches[1];
			$minutes = intval($minutes);
			$minutes = $minutes * 60;
			$totaltime = $totaltime + $minutes;
		}
		
		preg_match('/(\d+)s/i', $videoStartTime, $matches); //get seconds
		if (count($matches)) { 
			$seconds = $matches[1];
			$seconds = intval($seconds);
			$totaltime = $totaltime + $seconds;
		}
		
		if(isset($totaltime)) {
			$videoStartTime = $totaltime;
		}
	}
	
	$response = file_get_contents("https://www.youtube.com/get_video_info?video_id=$id");
	
	//create object from responseString
	$decodedResponse = urldecode($response);
	parse_str($decodedResponse, $parsedResponse);
	$playerResponse = $parsedResponse['player_response'];
	$responseObject = json_decode($playerResponse, true);
	
	$videoDetails = $responseObject['videoDetails'];
	$durationSeconds = $videoDetails['lengthSeconds'] ?? 0;
	$title = $videoDetails['title'];
	
	//convert seconds to H:M:S
	$dtF = new \DateTime('@0');
	$dtT = new \DateTime("@$durationSeconds");
	$videoDuration = $dtF->diff($dtT)->format('%H:%I:%S');
	
    //set Youtube background image
    $backgroundUrl = "https://i.ytimg.com/vi/" . $id . "/hqdefault.jpg";
	
	//build display URL
	$displayUrl = "https://youtube.com/watch?v=$id";
	
	//build data URL
	$api = "https://www.youtube.com/embed/$id?";
	$options = [
		'autoplay' => 1,
		'autohide' => 1,
		'border' => 0,
		'wmode' => 'opaque',
		'enablejsapi' => 1,
		'start' => $videoStartTime,
		'fs' => 1,
		'allowFullScreen' => 'true',
    ];
	$query = http_build_query($options);
	$dataUrl = $api.$query;
	
	$output = [
		'status' => 8, //8=finished
		'type' => $type,
		'displayUrl' => $displayUrl,
		'dataUrl' => $dataUrl,
		'title' => $title,
		'videoDuration' => $videoDuration,
		'backgroundUrl' => $backgroundUrl,
	];
	
	return $output;
}


?>