<?php namespace RWMedia;

class Crypto {
	
	public static function rwHash($string) {
		$binary = hash('sha256', $string, true); //true=get binary
		return self::base64_url_encode($binary);
	}
	
	public static function generateRwid($string) {
		$id = self::rwHash($string);
		
		return "rwid=$id";
	}
	
	public static function base64_url_encode($input) {
		return strtr(base64_encode($input), '+/=', '@_-');
	}
	
	public static function base64_url_decode($input) {
		return base64_decode(strtr($input, '@_-', '+/='));
	}
	
	public static function decodeAndEncodeBase64($string) {
		return self::base64_url_encode(self::base64_url_decode($string, true));
	}
	
}